{ pkgs, ... }:

{
  c3d2.deployment.server = "server10";

  # microvm.mem = 1 * 1024;

  networking.hostName = "pretalx";

  services = {
    # backup.enable = true;

    nginx = {
      enable = true;
      virtualHosts."pretalx.c3d2.de" = {
        default = true;
        forceSSL = true;
        enableACME = true;
        locations."/".proxyPass = "http://127.0.0.1:3000";
        serverAliases = [ "pretalx.datenspuren.de" "talks.datenspuren.de" ];
      };
    };

    postgresql = {
      package = pkgs.postgresql_16;
      # upgrade.stopServices = [ "" ];
    };
  };

  sops = {
    # defaultSopsFile = ./secrets.yaml;
  };

  system.stateVersion = "23.11";
}
